/** \file   my_cache.h
 *  \brief  A cache for binary operations
 *  \author Takahisa Toda
 */
#ifndef MY_CACHE_H
#define MY_CACHE_H

#define CACHE_DEFAULT_SIZE        (16777216UL  + 43)     //!< 2^{24} + 43 
//#define CACHE_DEFAULT_SIZE       (1UL << 20)

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/** \brief my cache */
struct my_cache {
  size_t nent;   //!< the number of cache entries
  size_t *entry; //!< the i-th entry has size CACHE_ENTRY_SIZE and start from the position i*CACHE_ENTRY_SIZE, where 0 <= i < num.
};

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
extern struct my_cache *cache_create(size_t num);
extern void cache_destroy(struct my_cache *ch);
extern void cache_add(size_t op, size_t k1, size_t k2, size_t r, struct my_cache *ch);
extern int cache_search(size_t op, size_t k1, size_t k2, size_t *pr, const struct my_cache *ch);
extern void cache_enlarge(struct my_cache *ch);

#endif /*MY_CACHE_H*/
